﻿function ImgCut(config)
{
	this.clientW=window.innerWidth || document.body.clientWidth;
	this.clientH=window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
	this.img='';
	if(typeof(config)!='object') config={};
	
	this.param={};
	this.param.type=config.type || 'auto';//type: cut 剪切 width 宽标准 height 高标准 auto 自动
	this.param.width=config.width || 300;
	this.param.height=config.height || 300;
	this.param.show=config.show || 0;//显示图片
	this.param.encoderOptions=config.encoderOptions || 0.8;//分辨率
	this.param.savetype=config.savetype || '';//保存图片类型
	this.func='';
	this.result={};
	
	//检测是否支持
	this.check=function(){
		if(typeof(FileReader)=='undefined')
		{
			_this.result.isfile=0;
			_this.result.error = "浏览器不支持FileReader，请换其他浏览器";
		}
		else
		{
			_this.result.isfile=1;
		}
		_this.back(3);
	}
	//本地图片剪切
	this.file=function(func){
		if(typeof(func)=='function') this.func=func;
		if(typeof(FileReader)=='undefined')
		{
			_this.result.error = "浏览器不支持FileReader，请换其他浏览器";
			_this.back(1);
			return false;
		}
		
		var input=document.createElement("input");  // 以 DOM 创建新元素
		input.type="file";
		input.accept = 'image/*';
		input.name="upfile";
		$(input).change(function(){
			var file = this.files[0];//获取input输入的图片
			_this.result.name=file.name;
			if(!/image\/\w+/.test(file.type))
			{
				_this.result.error = "请确保文件为图像类型";
				_this.back(1);
				return false;
			}//判断是否图片，在移动端由于浏览器对调用file类型处理不同，虽然加了accept = 'image/*'，但是还要再次判断
			var reader = new FileReader();
			reader.readAsDataURL(file);//转化成base64数据类型
			reader.onload = function(e){
				//irm.storage.set('base64',this.result);
				_this.base64(this.result);
				delete(reader);
			}
			$(input).remove();
		});
		$(input).click();
	}
	
	//base64图片剪切
	this.base64=function(imgData,func){
		if(typeof(func)=='function') this.func=func;
		if(!this.param.savetype)
		{
			var strat=imgData.indexOf(':')+1;
			var end=imgData.indexOf(';',strat);
			this.param.savetype=imgData.substr(strat,end-strat);
		}
		
		_this.img = new Image;
		_this.img.src = imgData;
		_this.img.onload = function(){//必须onload之后再画
			EXIF.getData(_this.img, function(){
				var Orientation=EXIF.getTag(_this.img, 'Orientation');
				if(Orientation==6)//顺时针旋转90
				{
					var cvs = document.createElement('canvas');
					var width=_this.img.height;
					var height=_this.img.width;
					cvs.width=width;
					cvs.height=height;
					var ctx = cvs.getContext('2d');
					ctx.rotate(90*Math.PI/180);
					ctx.translate(0,-width);
					ctx.drawImage(_this.img,0,0,height,width);
					var data = cvs.toDataURL();
					_this.img.remove();
					_this.base64(data);	
					return;					
				}
				else if(Orientation==8)//逆时针旋转90
				{
					var cvs = document.createElement('canvas');
					var width=_this.img.height;
					var height=_this.img.width;
					cvs.width=width;
					cvs.height=height;
					var ctx = cvs.getContext('2d');
					ctx.rotate(270*Math.PI/180);
					ctx.translate(-height,0);
					ctx.drawImage(_this.img,0,0,height,width);
					var data = cvs.toDataURL();
					_this.img.remove();
					_this.base64(data);
					return;					
				}
				else if(Orientation==3)//旋转180度
				{
					var cvs = document.createElement('canvas');
					var width=_this.img.width;
					var height=_this.img.height;
					cvs.width=width;
					cvs.height=height;
					var ctx = cvs.getContext('2d');
					ctx.rotate(180*Math.PI/180);
					ctx.translate(-width,-height);
					ctx.drawImage(_this.img,0,0,width,height);
					var data = cvs.toDataURL();
					_this.img.remove();
					_this.base64(data);
					return;					
				}
				if(_this.param.type=='cut')
				{
					_this.cc(_this.img);
				}
				else
				{
					var param=_this.s(_this.param.type,_this.param.width,_this.param.height,_this.img.width,_this.img.height);
					_this.sv(param);
				}
			});
		}
	},
	//保存
	this.sv=function(ret){
		var cvs = document.createElement('canvas');
		var imgw=ret.width;
		var imgh=ret.height;
		cvs.width=ret.w;
		cvs.height=ret.h;
		var x=ret.x || 0;
		var y=ret.y || 0;
		var ctx = cvs.getContext('2d');
		ctx.drawImage(_this.img,x,y,imgw,imgh);
		_this.result.base64data = cvs.toDataURL(_this.param.savetype,_this.param.encoderOptions);//获取canvas base64数据
		_this.back(3);
		
		//$(_this.img).remove();
		if(_this.param.show)
		{
			$('body').append(cvs);
		}
		else
		{
			$(cvs).remove();
		}
	},
	//返回
	this.back=function(status){
		this.result.status=status;
		if(typeof(this.func)=='function')
		{
			this.func && this.func(this.result);
		}
	}
	//获取尺寸
	this.s=function(type,width,height,imgw,imgh){
		var ret={};
		if(type=='width')
		{
			ret.width=width;
			ret.height=width*imgh/imgw;
		}
		else if(type=='height')
		{
			ret.height=height;
			ret.width=height*imgw/imgh;
		}
		else
		{
			if(width/height>imgw/imgh)
			{
				ret.height=Math.min(height,imgh);
				ret.width=ret.height*imgw/imgh;	
			}
			else
			{
				ret.width=Math.min(width,imgw);
				ret.height=ret.width*imgh/imgw;
			}
		}
		ret.w=ret.width;
		ret.h=ret.height;
		return ret;
	}
	
	this.cc=function(img){
		var objs=[];
		
		var Cut_width=Math.min(_this.clientW*2/3,400);//剪切板宽度
		var Cut_height=Math.min(_this.clientH*2/3,400);//剪切板高度
		
		//屏幕宽度大于高度
		if(Cut_width/Cut_height>this.param.width>this.param.height)
		{
			Cut_height=Math.min(Cut_height,this.param.height);
			Cut_width=Cut_height*this.param.width/this.param.height;
		}
		else
		{
			Cut_width=Math.min(Cut_width,this.param.width);
			Cut_height=Cut_width*this.param.height/this.param.width;
		}
		
		var Cut_left=(_this.clientW-Cut_width)/2;//剪切板左边距
		var Cut_top=(_this.clientH-Cut_height)/2;//剪切板上边距
		
		if(Cut_width/Cut_height>img.width>img.height)
		{
			var img_height=Math.min(Cut_height,img.height);
			var img_width=img_height*img.width/img.height;
		}
		else
		{
			var img_width=Math.min(Cut_width,img.width);
			var img_height=img_width*img.height/img.width;
		}
		
		var img_left=(_this.clientW-img_width)/2;
		var img_top=(_this.clientH-img_height)/2;
		
		//剪切
		var cut=function(){
			var ret={};
			ret.w=_this.param.width;
			ret.h=_this.param.height;
			var lv=ret.w/Cut_width;
			ret.width=lv*img_width;
			ret.height=lv*img_height;
			ret.x=(img_left-Cut_left)*lv;
			ret.y=(img_top-Cut_top)*lv;
			_this.sv(ret);
			for(var i=0;i<objs.length;i++)
			{
				$(objs[i]).remove();
			}
		}
		//验证图片
		var check=function(param){
			var width=$(img).width();//图片宽度
			var height=$(img).height();//图片高度
			
			if(typeof(param)=='object')
			{
				if(param.width)
				{
					height=param.width*height/width;
					width=param.width;
				}
				else
				{
					if(param.height)
					{
						width=param.height*width/height;
						height=param.height;
					}
				}
			}
			
			//图片宽度小于剪切板宽度
			if(width<Cut_width)
			{
				height=Cut_width*height/width;
				width=Cut_width;
			}
			//图片高度小于剪切板高度
			if(height<Cut_height)
			{
				width=Cut_height*width/height;
				height=Cut_height;
			}
			
			//图片大小改变
			if(width!=img_width)
			{
				$(img).width(width);
				$(img).height(height);
				
				var lv=(width-img_width)/img_width;
				
				img_left=img_left-width*lv/2;
				img_top=img_top-height*lv/2;
				$(img).css('left',img_left+'px');
				$(img).css('top',img_top+'px');
				
				img_width=width;
				img_height=height;
			}
			
			//图片上边距不得大于剪切板上边距
			if(img_top>Cut_top)
			{
				$(img).css('top',Cut_top+'px');
			}
			//图片右边距不得小于剪切板右边距
			if(img_left+img_width<Cut_left+Cut_width)
			{
				var _l=Cut_left+Cut_width-img_width;
				$(img).css('left',_l+'px');
			}
			//图片下边距不得小于剪切板下边距
			if(img_top+img_height<Cut_top+Cut_height)
			{
				var _t=Cut_top+Cut_height-img_height;
				$(img).css('top',_t+'px');
			}
			//图片左边距不得大于剪切板左边距
			if(img_left>Cut_left)
			{
				$(img).css('left',Cut_left+'px');
			}
			
			img_left=$(img).offset().left;
			img_top=$(img).offset().top;
		}		
		
		//移动缩放
		var move=function(param){
			if(param.left)
			{
				var _left=$(img).offset().left+param.left;
				$(img).css('left',_left+'px');
				img_left=_left;
			}
			if(param.top)
			{
				var _top=$(img).offset().top+param.top;
				$(img).css('top',_top+'px');
				img_top=_top;
			}
			if(param.lv)
			{
				var lv=1+param.lv;
				var width=img_width*lv;
				var height=img_height*lv;
				img_left=img_left-width*param.lv/2;
				img_top=img_top-height*param.lv/2;
				$(img).width(width);
				$(img).height(height);
				$(img).css('left',img_left+'px');
				$(img).css('top',img_top+'px');
				img_width=width;
				img_height=height;
			}
		}
		
		var mtype=0;//移动类型	
		//操作按钮
		var navbtn=function(){
			var _top=Cut_top;
			_top-=40;
			if(_top<0) _top=0;
			
			var div = document.createElement("div");
			$(div).attr('style','text-align:center;position:fixed;top:'+_top+'px;width:100%;z-index:99999;');
			$(objs[5]).append(div);
			var tagas=[];
			var t=0;
			for(var i=0;i<5;i++)
			{
				tagas[i]=document.createElement("span");
				$(tagas[i]).attr('style','color:#fff;background:#3d7ace;display:inline-block;font-size:12px;height:14px;padding:5px 8px;border-radius:5px;margin:0px 5px;');
				$(div).append(tagas[i]);
				switch(i)
				{
					case 0:
						$(tagas[i]).html('放大');
						if(typeof(tagas[i].ontouchstart)=='object')
						{
							$(tagas[i]).click(function(){
								move({lv:0.1});
							})
						}
						else
						{
							$(tagas[i]).bind("mousedown",function(ev){
								mtype=1;
								t=setInterval(function(){
									move({lv:0.02});
								},100)
							});
							$(tagas[i]).bind("mouseup",function(){
								if(mtype==1)
								{
									clearInterval(t);
									check();
									mtype=0;
								}
							});
							$(tagas[i]).bind("mouseout",function(){
								if(mtype==1)
								{
									clearInterval(t);
									check();
									mtype=0;
								}
							});
						}
					break;
					case 1:
						$(tagas[i]).html('缩小');
						if(typeof(tagas[i].ontouchstart)=='object')
						{
							$(tagas[i]).click(function(){
								move({lv:-0.1});
							})
						}
						else
						{
							$(tagas[i]).bind("mousedown",function(ev){
								mtype=1;
								t=setInterval(function(){
									move({lv:-0.02});
								},100)
							});
							$(tagas[i]).bind("mouseup",function(){
								if(mtype==1)
								{
									clearInterval(t);
									check();
									mtype=0;
								}
							});
							$(tagas[i]).bind("mouseout",function(){
								if(mtype==1)
								{
									clearInterval(t);
									check();
									mtype=0;
								}
							});
						}
					break;
					case 2:
						$(tagas[i]).html('左旋转');
						$(tagas[i]).click(function(){
							alert('左旋转')
						})
					break;
					case 3:
						$(tagas[i]).html('右旋转');
						$(tagas[i]).click(function(){
							alert('右旋转')
						})
					break;
					case 4:
						$(tagas[i]).html('保存2');
						$(tagas[i]).bind("click",function(ev){
							alert('cc');
							cut();
						});
					break;
				}
			}
		}
		//鼠标移动事件
		var mouse=function(){
			var ismove=0;
			var startX=0;
			var startY=0;
			
			$(objs[5]).bind("mousedown",function(ev){
				ismove=1;
				var ev=ev || window.event;
				startY=ev.clientY;
				startX=ev.clientX;
			});
			
			$(objs[5]).bind("mouseup",function(){
				ismove=0;
				check();
			});
			
			$(objs[5]).bind("mousemove",function(ev){
				if(ismove==1)
				{
					var ev=ev || window.event;
					move({left:ev.clientX-startX,top:ev.clientY-startY});
					startY=ev.clientY;
					startX=ev.clientX;
				}
			});
			$(objs[5]).bind("dblclick",function(){
				cut();
			});
		}
		//触摸移动事件
		var touch=function(){
			var zoom_dis=0;//距离
			var startX=0;
			var startY=0;
			
			//获取两点距离
			var Coutdis=function(touchs){
				var dis_x=touchs[1].clientX-touchs[0].clientX;
				var dis_y=touchs[1].clientY-touchs[0].clientY;
				var dis=Math.sqrt(Math.pow(dis_x,2)+Math.pow(dis_y,2));
				return dis;
			}
			
			var touchmove=function(ev){
				ev.preventDefault();
				// 如果这个元素的位置内多余一个出点
				if (ev.targetTouches.length>1) 
				{
					var dis=Coutdis(ev.targetTouches);
					var lv=(dis-zoom_dis) / zoom_dis;
					move({lv:lv});
					zoom_dis=dis;
				}
				else
				{
					move({left:ev.targetTouches[0].clientX-startX,top:ev.targetTouches[0].clientY-startY});
					startX=ev.targetTouches[0].clientX;
					startY=ev.targetTouches[0].clientY;
				}
			}
			
			var touchstart=function(ev){
				//ev.preventDefault();
				// 如果这个元素的位置内多余一个出点
				if (ev.targetTouches.length>1) 
				{
					zoom_dis=Coutdis(ev.targetTouches);
				}
				else
				{
					//起始位置
					startX=ev.targetTouches[0].clientX;
					startY=ev.targetTouches[0].clientY;
				}
				
				document.ontouchmove=touchmove;
			}
			document.ontouchstart=touchstart;
			
			//停止
			document.ontouchend=function(ev){
				document.ontouchmove='';
				ev.returnValue = true;
				check();
			}
			//剪切
			objs[0].onclick=function(){
				cut();
			}
		}
		
		for(var i=0;i<7;i++)
		{
			objs[i]=document.createElement("div");
			document.body.appendChild(objs[i]);
			$(objs[i]).css('position','fixed');
			objs[i].style.zIndex = "9999";
			if(i==0)
			{
				objs[i].style.zIndex = "999999";
				$(objs[i]).css('top',Cut_top+'px');
				$(objs[i]).css('left',Cut_left+'px');
				$(objs[i]).css('width',Cut_width+'px');
				$(objs[i]).css('height',Cut_height+'px');
			}
			else if(i==5)
			{
				$(objs[i]).css('position','fixed');
				objs[i].style.zIndex = "99999";
				$(objs[i]).css('top','0px');
				$(objs[i]).css('left','0px');
				$(objs[i]).width(_this.clientW);
				$(objs[i]).height(_this.clientH);
				if(typeof(objs[i].ontouchstart)=='object')
				{
					touch();
				}
				else
				{
					mouse();
				}
			}
			else if(i==6)
			{
				$(objs[i]).css('position','fixed');
				objs[i].style.zIndex = "999";
				$(objs[i]).css('top','0px');
				$(objs[i]).css('left','0px');
				$(objs[i]).width(_this.clientW);
				$(objs[i]).height(_this.clientH);
				$(objs[i]).append(img);
			}
			else
			{
				objs[i].style.background = "#000"; 
				objs[i].style.filter = "Alpha(opacity=80);"; 
				objs[i].style.opacity = "0.8";
				switch(i)
				{
					case 1:
						$(objs[i]).css('top','0px');
						$(objs[i]).css('left','0px');
						$(objs[i]).css('width',_this.clientW+'px');
						$(objs[i]).css('height',Cut_top+'px');
					break;
					case 2:
						$(objs[i]).css('top',Cut_top+'px');
						$(objs[i]).css('left','0px');
						$(objs[i]).css('width',Cut_left+'px');
						$(objs[i]).css('height',Cut_height+'px');
					break;
					case 3:
						var __w=_this.clientW-Cut_left-Cut_width;
						$(objs[3]).css('top',Cut_top+'px');
						$(objs[3]).css('right','0px');
						$(objs[3]).css('width',__w+'px');
						$(objs[3]).css('height',Cut_height+'px');
					break;
					case 4:
						var __h=_this.clientH-Cut_top-Cut_height;
						$(objs[4]).css('bottom','0px');
						$(objs[4]).css('left','0px');
						$(objs[4]).css('width',_this.clientW+'px');
						$(objs[4]).css('height',__h+'px');
					break;
				}
			}
		}
		navbtn();
		$(img).css('position','fixed');
		$(img).css('top',img_top+'px');
		$(img).css('left',img_left+'px');
		$(img).css('width',img_width+'px');
		$(img).css('height',img_height+'px');
	}
	var _this=this;
	this.check();
}