/*
	极光推送
*/
Plug.ajpush={
	url:'http://i.xuezizhai.com/index.php?s=77&view=ajpush&cm=add&caid=5',
	init:function(){// 注册设备
		var self=this;
		var ajpush = api.require('ajpush');
		//苹果系统需要初始化
		if(api.systemType.toLowerCase()=='ios')
		{
			//设置消息监听，若iOS应用在前台运行，此时收到推送后也通过此方法回调
			var ajpush = api.require('ajpush');
			ajpush.setListener(
				function(ret)
				{
					var id = ret.id;
					var title = ret.title;
					var content = ret.content;
					var extra = ret.extra;//额外信息 键值对详细
					
					api.confirm({
						title: title,
						msg: content,
						buttons: ['查看', '取消']
					}, function(ret, err){
						var index = ret.buttonIndex;
						if(index==1)
						{
							self.extra(extra);
						}
					});
				}
			);
			//在iOS平台，使用极光推送发送通知时，若应用在前台运行，则推送内容可以通过setListener方法监听到，若应用在后台，系统会往设备通知栏发送通知，当通知被点击后，APICloud会将本次推送的内容通过事件监听回调的方式交给开发者。具体使用如下：
			api.addEventListener({
				name: 'noticeclicked'
			}, function(ret, err){
				if (ret && ret.value)
				{
					var ajpush = ret.value;
					var content = ajpush.content;
					var extra = ajpush.extra;
					if(typeof(extra)=='object')
					{
						self.extra(extra);
					}
				}
			})
		}
		//安卓系统
		else if(api.systemType.toLowerCase()=='android')
		{
			var ajpush = api.require('ajpush');
			ajpush.init(function(ret){
				//ret.status 操作成功状态值，1-成功，0-失败
				if (ret && ret.status==1)
				{
					
					
					//
				}
			});
			//在Android平台，使用极光推送发送通知、消息等类型推送时，极光推送模块会往设备状态栏上发送通知，当通知被点击后，APICloud会将本次推送的内容通过事件监听回调的方式交给开发者。具体使用如下：
			api.addEventListener({
				name: 'appintent'
			}, function(ret, err){
				if (ret && ret.appParam.ajpush){
					var ajpush = ret.appParam.ajpush;
					var extra = ajpush.extra;
					if(typeof(extra)=='object')
					{
						self.extra(extra);
					}
				}
			})
		}
		this.clear();
	},
	//额外信息
	extra:function(ret){
		if(typeof(ret)!='object') return;
		if(ret.url)
		{
			var item={name:'index/url',para:ret};
			App.Win.open(item);
		}
		else if(ret.name)
		{
			App.Win.open(ret);
		}
	},
	//绑定推送设备
	bind:function(user,func){
		var self=this;
		var ajpush = api.require('ajpush');
		ajpush.getRegistrationId(function(ret){
			var url=self.url+'&registrationid='+ret.id;
			getData({},function(ret){
				func && func();
			},{},url)
		});
	},
	//检测是否停止推送
	isstop:function(func){
		var ajpush = api.require('ajpush');
		ajpush.isPushStopped(function(ret){
			//isStopped 推送服务是否停止状态，1-停止，0-未停止
			func && func(ret);
		});
	},
	//停止Push推送。
	sotp:function(func){
		var ajpush = api.require('ajpush');
		ajpush.stopPush(function(ret){
			//status  操作成功状态值，1-成功，0-失败
			if(typeof(func)=='function') func && func(ret);
		});
	},
	//清除极光推送发送到状态栏的通知。
	clear:function(func){
		var ajpush = api.require('ajpush');
		var param = {id:-1};
		ajpush.clearNotification(param,function(ret){
			//status  操作成功状态值，1-成功，0-失败
			if(typeof(func)=='function') func && func(ret);
		});
		ajpush.setBadge({
			badge:0
		});
	}
}