/*
	缓存
*/
Plug.cache={
	/**缓存内容
	 *  
	 * @access    public 
	 * @param     string  key  字符串
	 * @param     function  func  回调函数
	 * @param     string  path 路径
	 * @return    bloo
	 */
	set:function(key,value,func,path,time){
		var file=this.getfile(key,path);
		var data={value:value};
		var time=time || 0;
		if(time)
		{
			var nowtime = Date.parse(new Date())/1000;
			data.expiretime=nowtime+time;
		}
		api.writeFile({
			path: file,
			data: JSON.stringify(data)
		}, function(ret, err){
			if(ret.status)
			{
				
			}
			else
			{
				ret.err=err;
				Log.system('缓存失败'+JSON.stringify(err),6);
			}
			if(typeof(func)=='function')
			{
				func && func(ret);
			}
		});
	},
	/**获取内容
	 *  
	 * @access    public 
	 * @param     string  key  字符串
	 * @param     function  func  回调函数
	 * @param     string  path 路径
	 * @return    string
	 */
	get:function(key,func,path){
		var file=this.getfile(key,path);
		//异步返回结果：
		api.readFile({
			path: file
		}, function(ret, err){
			if (ret.status)
			{
				try{
					var data=JSON.parse(ret.data);
					if(data.expiretime)
					{
						var expiretime=parseInt(data.expiretime);
						var nowtime = Date.parse(new Date())/1000;
						//已经过期
						if(expiretime<nowtime)
						{
							var ret={status:false,data:'过期'};
						}
						else
						{
							var ret={status:true,data:data.value};
						}
					}
					else
					{
						var ret={status:true,data:data.value};
					}
				}
				catch(err)
				{
					Log.system('缓存解码错误'+JSON.stringify(err),6);
					var ret={status:false,data:err};
			　　}
				finally
				{
			　　 　　//document.writeln("开始执行finally块语句")
				}
			}
			else
			{
				var ret={status:false,data:err};
			}
			if(typeof(func)=='function')
			{
				func && func(ret);
			}
		})
	},
	/**删除缓存
		name string 名称
		func  function 回调函数
	*/
	drop:function(key,func,path){
		var file=this.getfile(key,path);
		var fs = api.require('fs');
		fs.remove({
			path:file
		}, function(ret, err){
			if(typeof(func)=='function')
			{
				func && func(ret,err);
			}
		});
	},
	/**获取文件路径
	 *  
	 * @access    public 
	 * @param     string  key  字符串
	 * @param     string  path 路径
	 * @return    string
	 */
	getfile:function(key,path){
		var file='fs://cache/';
		if(path) file+=path+'/';
		var signature = api.require('signature');
		file+=signature.md5Sync({data:key,uppercase:false})+'.json';
		return file;
	}
}