﻿//模板更新检测
var Temp={
	//缓存模板
	cache:{
		//保存配置
		save:function(config){
			App.saveconfig(config);
		},
		//检测缓存模板是否存在
		check:function(config){
			var self=this;
			var fs = api.require('fs');
			fs.readDir({
				path:Config.cachedir
			}, function(ret, err){
				if (ret.status)
				{
					config.tempcache=1;
					self.save(config);
					Temp.update.init();
				}
				else
				{
					self.copy(config);
				}
			});
		},
		//复制模板到缓存
		copy:function(config){
			var self=this;
			var fs = api.require('fs');
			var newPath=Config.cachedir;
			
			//苹果手机
			if(api.systemType=='ios') newPath='fs://';
			
			var fs = api.require('fs');
			fs.copyTo({
				oldPath:Config.localdir,
				newPath:newPath
			}, function(ret, err){
				if (ret.status)
				{
					config.tempcache=1;
					self.save(config);
					Temp.update.reset(function(){
						Temp.update.init();
					})
				}
				else
				{
					//模板复制失败
					Log.system(Config.localdir+'模板复制失败'+newPath+JSON.stringify(err),3);
				}
			});
		}
	},
	//更新模板
	update:{
		key:'versionautoupdate',
		cachePath:'fs://xzztemp/widget/',
		//初始化数据库
		init:function(){
			var self=this;
			Plus_jsoncache.getcache(this.key,function(ret){
				if(ret.status)
				{
					//如果正在下载模板 继续下载
					if(ret.data.type)
					{
						if(ret.data.type=='down')
						{
							self.down(ret.data);
						}
						else if(ret.data.type=='copy')
						{
							self.copy(ret.data);
						}
						else if(ret.data.type=='finish')
						{
							self.finish(ret.data);
						}
					}
					else
					{
						//检测模板是否更新
						self.check(ret.data.temptime);
					}
				}
				else
				{
					self.check(Config.temptime);
				}
			})
		},
		//检测是否更新
		check:function(temptime){
			var self=this;
			App.getconfig(function(ret){
				//服务器时间大于客户端时间 模板更新
				if(ret.temptime>temptime)
				{
					self.get(temptime,ret.temptime);
				}
				else
				{
					Log.system('模板未更新',3);
				}
			});
		},
		//获取更新模板列表
		get:function(temptime,endtime){
			var self=this;
			var item={c:Config.c,cm:'gettemplists',starttime:temptime,endtime:endtime};
			getData(item,function(ret){
				if(ret.status==3)
				{
					var param={temptime:temptime,endtime:endtime,type:'down',lists:ret.data,index:0};
					self.set(param);
					self.down(param);
				}
				else
				{
					Log.system('获取更新模板列表失败',3);
				}
			})
		},
		//保存配置
		set:function(param){
			Plus_jsoncache.cache(this.key,param);
		},
		//重置参数
		reset:function(func){
			var self=this;
			Plus_jsoncache.drop(this.key,function(){
				var fs = api.require('fs');
				fs.rmdir({
					path:self.cachePath
				}, function(ret, err){
					if(typeof(func)=='function') func && func();
				});
			});
		},
		//下载模板
		down:function(param){
			var self=this;
			var fallnum=0;//下载失败次数
			var index=param.index || 0;
			var startdown=function(){
				var path=param.lists[index];
				//下载完毕
				if(!path)
				{
					param.type='copy';
					param.index=0;
					self.copy(param);
					return;
				}
				
				if(path.substr(0,1)=='/') path=path.substr(1);
				var url=Config.remotedir+path;
				var savepath=self.cachePath+path;
				
				api.download({
					url: url,
					savePath:savepath,
					report: false,
					cache: false,
					allowResume: false
				}, function(ret, err){
					//下载成功 继续下载
					if (ret.state == 1)
					{
						param.index=index;
						self.set(param);
						index++;
						startdown();
					}
					//下载失败 10秒之后重新下载
					else if (ret.state == 2)
					{
						fallnum++;
						
						if(fallnum>3)
						{
							Log.system('模板下载失败'+url,3);
						}
						
						setTimeout(function(){
							startdown();
						},10000)
					}
				});
			}
			startdown();
		},
		//复制更新模板
		copy:function(param){
			var self=this;
			var fallnum=0;//复制失败次数
			var fs = api.require('fs');
			var index=param.index || 0;
			
			//删除指定文件
			var fremove=function(file,func){
				fs.remove({
					path:file
				}, function(ret, err){
					if (ret.status)
					{
						//alert(JSON.stringify(ret));
					} 
					else
					{
						//alert(JSON.stringify(err));
					}
					if(typeof(func)=='function') func && func();
				});
			}
			//复制指定文件
			var fcopy=function(){
				var path=param.lists[index];
				//下载完毕
				if(!path)
				{
					param.type='finish';
					self.finish(param);
					return;
				}

				if(path.substr(0,1)=='/') path=path.substr(1);
				var newFile=Config.cachedir+path;
				var newpath=newFile.substr(0,newFile.lastIndexOf('/'));
				var oldFile=self.cachePath+path;

				fremove(newFile,function(){
					fs.copyTo({
						oldPath:oldFile,
						newPath:newpath
					}, function(ret, err){
						if (ret.status)
						{
							param.index=index;
							self.set(param);
							index++;
							fremove(oldFile);
							fcopy();//继续复制
						}
						else
						{
							fallnum++;
							
							if(fallnum>3)
							{
								Log.system('模板复制失败'+oldFile+' '+newFile,3);
							}
							//执行错误10秒后重新执行
							setTimeout(function(){
								fcopy();
							},10000)
						}
					});
				});
			}
			fcopy();
		},
		//复制完毕
		finish:function(param){
			param.temptime=param.endtime;
			param.type='';
			param.index=0;
			param.lists=[];
			this.set(param);
			//alert('更新完毕');
		}
	}
}